﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class NestedGrids : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void RadGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DataTable table = new DataTable();
        table.Columns.Add("Column1");
        table.Columns.Add("Column2");
        table.Columns.Add("Column3");

        for (int i = 0; i < 10; i++)
        {
            table.Rows.Add("Col1Row" + i, "Col2Row" + i, "Col3Row" + i);
        }

        (sender as RadGrid).DataSource = table;
    }

    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        if (isExport)
        {
            ExpandAllItems(RadGrid1);
        }
    }

    private void ExpandAllItems(RadGrid grid)
    {
        foreach (GridDataItem item in grid.MasterTableView.Items)
        {
            item.Expanded = true;
            if (item.ChildItem != null)       
            {
                RadGrid nestedGrid = item.ChildItem.Controls[1].Controls[0].Controls[1] as RadGrid;
                nestedGrid.Rebind();
                ExpandAllItems(nestedGrid);
            }
        }
    }


    bool isExport = false;
    protected void Button1_Click(object sender, EventArgs e)
    {
        isExport = true;
        RadGrid1.MasterTableView.ExportToExcel();
    }
}